#ifdef PROFILE_GENERATE
void __libc_init_array (void);
/* These magic symbols are provided by the linker.  */
extern void (*__preinit_array_start []) (void) __attribute__((weak));
extern void (*__preinit_array_end []) (void) __attribute__((weak));
extern void (*__init_array_start []) (void) __attribute__((weak));
extern void (*__init_array_end []) (void) __attribute__((weak));
extern void (*__fini_array_start []) (void) __attribute__((weak));
extern void (*__fini_array_end []) (void) __attribute__((weak));

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus
extern void gcov_exit (void);
extern void _init (void);
extern void _fini (void);
#ifdef __cplusplus
}
#endif // __cplusplus

/* Iterate over all the init routines.  */
void __libc_init_array (void)
{
  int count;
  int i;

  count = __preinit_array_end - __preinit_array_start;
  for (i = 0; i < count; i++)
    __preinit_array_start[i] ();

  //_init();

  count = __init_array_end - __init_array_start;
  for (i = 0; i < count; i++)
    __init_array_start[i] ();
}

/* Run all the cleanup routines.  */
void
__libc_fini_array (void)
{
  unsigned int count;
  unsigned int i;
  
  count = __fini_array_end - __fini_array_start;
  for (i = 0; i < count; i++)
    __fini_array_start[i] ();

  //_fini();
}


#endif // PROFILE_GENERATE


/*
 * These function are only here to call the libgcov functions when in profile-generate mode
 * Need to define PROFILE_GENERATE
 * And NOT include the -fprofile-generate flag for this file!
 */

/* Call this function first thing */
void gp32_gcov_init (void)
{
#ifdef PROFILE_GENERATE
        __libc_init_array();
#endif
}

/* Call this function very last */
void gp32_gcov_exit (void)
{
#ifdef PROFILE_GENERATE
        gcov_exit();
#endif
}
