/* 
 * OpenTyrian Classic: A modern cross-platform port of Tyrian
 * Copyright (C) 2007-2009  The OpenTyrian Development Team
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#include "opentyr.h"
#include "network_stub.h"

#include "episodes.h"
#include "fonthand.h"
#include "helptext.h"
#include "joystick.h"
#include "keyboard.h"
#include "mainint.h"
#include "newshape.h"
#include "nortvars.h"
#include "picload.h"
#include "varz.h"
#include "video.h"

#include "SDL.h"

#include <assert.h>


#define NET_VERSION       2            // increment whenever networking changes might create incompatability
#define NET_PORT          1333         // UDP

#define NET_PACKET_SIZE   256
#define NET_PACKET_QUEUE  16

#define NET_RETRY         640          // ticks to wait for packet acknowledgement before resending
#define NET_RESEND        320          // ticks to wait before requesting unreceived game packet
#define NET_KEEP_ALIVE    1600         // ticks to wait between keep-alive packets
#define NET_TIME_OUT      16000        // ticks to wait before considering connection dead

bool isNetworkGame = false;
int network_delay = 1 + 1;  // minimum is 1 + 0

char *network_opponent_host = 0;

Uint16 network_player_port = NET_PORT,
       network_opponent_port = NET_PORT;

char *network_player_name = "",
     *network_opponent_name = "";

//UDPsocket socket;
//IPaddress ip;

//UDPpacket *packet_out_temp, *packet_temp;

//UDPpacket *packet_in[NET_PACKET_QUEUE] = { NULL },
//          *packet_out[NET_PACKET_QUEUE] = { NULL };

Uint16 last_out_sync = 0, queue_in_sync = 0, queue_out_sync = 0, last_ack_sync = 0;
Uint32 last_in_tick = 0, last_out_tick = 0;

//UDPpacket *packet_state_in[NET_PACKET_QUEUE] = { NULL },
//          *packet_state_in_xor[NET_PACKET_QUEUE] = { NULL },
//          *packet_state_out[NET_PACKET_QUEUE] = { NULL };

Uint16 last_state_in_sync = 0, last_state_out_sync = 0;
Uint32 last_state_in_tick = 0;

bool connected = false;


JE_integer thisPlayerNum = 0;  /* Player number on this PC (1 or 2) */

JE_boolean haltGame = false;

JE_boolean moveOk;

/* Special Requests */
JE_boolean pauseRequest, skipLevelRequest, helpRequest, nortShipRequest;
JE_boolean yourInGameMenuRequest, inGameMenuRequest;

JE_boolean portConfigChange;


// prepare new packet for sending
void network_prepare( Uint16 type )
{
}

// send packet and place it in queue to be acknowledged
bool network_send( int len )
{
	return true;
}

// send packet but don't expect acknoledgment of delivery
bool network_send_no_ack( int len )
{
	return true;
}

// poll for new packets received, check that connection is alive, resend queued packets if necessary
int network_check( void )
{
	return 0;
}

// send acknowledgement packet
int network_acknowledge( Uint16 sync )
{
	return 0;
}

// discard working packet, now processing next packet in queue
bool network_update( void )
{
	return false;
}

// has opponent gotten all the packets we've sent?
bool network_is_sync( void )
{
	return true;
}

// activity lately?
bool network_is_alive( void )
{
	return true;
}


// prepare new state for sending
void network_state_prepare( void )
{
}

// send state packet, xor packet if applicable
int network_state_send( void )
{
	return 0;
}

// receive state packet, wait until received
bool network_state_update( void )
{
	return true;
}

// ignore first network_delay states of level
bool network_state_is_reset( void )
{
	return true;
}

// reset queues for new level
void network_state_reset( void )
{
}


// attempt to punch through firewall by firing off UDP packets at the opponent
// exchange game information
int network_connect( void )
{
	return 0;
}

// something has gone wrong :(
void network_tyrian_halt( int err, bool attempt_sync )
{
}

int network_init( void )
{
	return 0;
}

void JE_clearSpecialRequests( void )
{
}

// kate: tab-width 4; vim: set noet:
